#include <stdio.h>

#ifndef GAA_NO_WIN32
#if defined(_WIN32) || defined(__WIN32__) || defined(WIN32) || defined(WINDOWS)
#define GAA_WIN32
#endif
#endif

void __gaa_helpsingle(char short_name, char *name, 
	char *arg_desc, char *opt_help)
{
     int col1, col3, col4, tabsize = 3, curr;
     int i;

     col1 = 5; /* Default values */
     col3 = 30;
     col4 = 70;

     curr = 0;
     for(i = 0; i < col1; i++)
        {
        printf(" ");
        curr++;
        }
     if(short_name)
        {
        if(name && *name)
          {
            printf("-%c, ", short_name);
            curr += 4;
          }
        else
          {
            printf("-%c ", short_name);
            curr += 3;
          }
        }
     if(name && *name)
        {
          printf("--%s ", name);
          curr += 3 + strlen(name);
        }
     if(arg_desc && *arg_desc)
        {
          printf("%s ", arg_desc);
          curr += 1 + strlen(arg_desc);
        }
     if(curr >= col3)
        {
          printf("\n");
          curr = 0;
        }
     if(opt_help) /* let's print the option's help body */
        {
        const char *str = opt_help;
        while(*str)
          {
             while(curr < col3)
               {
                 printf(" ");
                 curr++;
               }
             switch(*str)
               {
                 case '\n':
                     printf("\n");
                     curr = 0;
                     break;
                 case '\t':
                     do
                        {
                        printf(" ");
                        curr++;
                        }
                     while((curr - col3) % tabsize != 0 && curr < col4);
                 case ' ':
                     if(*str == ' ')
                        {
                        curr++;
                        printf(" ");
                        }
                     for(i = 1; str[i] && str[i] != ' ' && str[i] != '\n'
                        && str[i] != '\t'; i++);
                     if(curr + i - 1 >= col4)
                        curr = col4;
                     break;
                default:
                     printf("%c", *str);
                     curr++;
               }
             if(curr >= col4)
               {
                 printf("\n");
                 curr = 0;
               }
             str++;
          }
        }
     printf("\n");
}

void gaa_help()
{
	printf("ID3 options:""\n");
	__gaa_helpsingle('s', "songname", "", "set songname");
	__gaa_helpsingle('a', "artist", "", "set artist");
	__gaa_helpsingle('l', "album", "", "set album");
	__gaa_helpsingle('c', "comment", "", "set comment");
	__gaa_helpsingle('y', "year", "", "set release year");
	__gaa_helpsingle('t', "tracknum", "", "set track number");
	printf("\nGenre Options:""\n");
	__gaa_helpsingle('g', "genre", "", "set genre by ID");
	__gaa_helpsingle('G', "strgenre", "", "set genre by string");
	__gaa_helpsingle('L', "listgenres", "", "list supported genres");
	__gaa_helpsingle('i', "idtostr", "", "lookup a genre by id");
	__gaa_helpsingle('j', "strtoid", "", "lookup a genre by string");
	printf("\nMisc options:""\n");
	__gaa_helpsingle('v', "verbose", "", "be verbose");
	printf("""\n");

#line 100 "gaa.skel"
}
/* Copy of C area */

#line 104 "gaa.skel"
/* GAA HEADER */
#ifndef GAA_HEADER_POKY
#define GAA_HEADER_POKY

typedef struct _gaainfo gaainfo;

struct _gaainfo
{
#line 61 "Popol.gaa"
	char **files;
#line 60 "Popol.gaa"
	int files_num;
#line 55 "Popol.gaa"
	int verbose;
#line 36 "Popol.gaa"
	char *strgenre;
#line 32 "Popol.gaa"
	int genre;
#line 31 "Popol.gaa"
	int want_genre;
#line 21 "Popol.gaa"
	int want_track;
#line 20 "Popol.gaa"
	unsigned char tracknum;
#line 17 "Popol.gaa"
	char *year;
#line 14 "Popol.gaa"
	char *comment;
#line 11 "Popol.gaa"
	char *album;
#line 8 "Popol.gaa"
	char *artist;
#line 5 "Popol.gaa"
	char *songname;
#line 3 "Popol.gaa"
	int write_mode;

#line 114 "gaa.skel"
};

#ifdef __cplusplus
extern "C"
{
#endif

    int gaa(int argc, char *argv[], gaainfo *gaaval);

    void gaa_help();
    
    int gaa_file(char *name, gaainfo *gaaval);
    
#ifdef __cplusplus
}
#endif


#endif

#line 135 "gaa.skel"

/* C declarations */

#define GAAERROR    \
{                   \
gaa_error = 1;      \
return;        \
}

char *gaa_current_option;
int gaa_error = 0;

/* Generated by gaa */

#include <string.h>
#include <stdlib.h>


#define GAA_OK                       -1

#define GAA_ERROR_NOMATCH            0
#define GAA_ERROR_NOTENOUGH_ARGS     1
#define GAA_ERROR_INVALID_ARG        2
#define GAA_ERROR_UNKNOWN            3

#define GAA_NOT_AN_OPTION       0
#define GAA_WORD_OPTION         1
#define GAA_LETTER_OPTION       2
#define GAA_MULTIPLE_OPTION     3

#define GAA_REST                0
#define GAA_NB_OPTION           12
#define GAAOPTID_verbose	1
#define GAAOPTID_strtoid	2
#define GAAOPTID_idtostr	3
#define GAAOPTID_listgenres	4
#define GAAOPTID_strgenre	5
#define GAAOPTID_genre	6
#define GAAOPTID_tracknum	7
#define GAAOPTID_year	8
#define GAAOPTID_comment	9
#define GAAOPTID_album	10
#define GAAOPTID_artist	11
#define GAAOPTID_songname	12

#line 168 "gaa.skel"

#define GAA_CHECK1STR(a,b)      \
if(a[0] == str[0])              \
{                               \
    gaa_current_option = a;     \
    return b;                   \
}

#define GAA_CHECKSTR(a,b)                \
if(strcmp(a,str) == 0)                   \
{                                        \
    gaa_current_option = a;              \
    return b;                            \
}

#define GAA_TESTMOREARGS                                                  \
if(!OK)                                                                     \
{                                  \
while((gaa_last_non_option != gaa_index) && (gaa_arg_used[gaa_index] == 1)) \
    gaa_index++;                                                            \
if(gaa_last_non_option == gaa_index)                                        \
    return GAA_ERROR_NOTENOUGH_ARGS; \
}

#define GAA_TESTMOREOPTIONALARGS                                                  \
if(!OK) \
{ \
while((gaa_last_non_option != gaa_index) && (gaa_arg_used[gaa_index] == 1)) \
    gaa_index++;                                                            \
if(gaa_last_non_option == gaa_index)                                        \
    OK = 1; \
}

#define GAA_FILL_2ARGS(target, func)           \
target = func(GAAargv[gaa_index]);       \
gaa_arg_used[gaa_index] = 1;             \
if(gaa_error == 1)                       \
{                                        \
    gaa_error = 0;                       \
    return GAA_ERROR_INVALID_ARG;        \
} 



#define GAA_FILL(target, func, num)           \
if(!OK) \
{ \
target = func(GAAargv[gaa_index]);       \
gaa_arg_used[gaa_index] = 1;             \
if(gaa_error == 1)                       \
{                                        \
    gaa_error = 0;                       \
    return GAA_ERROR_INVALID_ARG;        \
} \
num = 1;  \
} \
else \
{ \
num = 0; \
}

#define GAA_LIST_FILL(target, func, type ,num)                      \
if(!OK) \
{ \
num = 0;                                                            \
target = malloc((gaa_last_non_option - gaa_index) * sizeof(type));  \
for(; gaa_index < gaa_last_non_option; gaa_index++)                 \
{                                                                   \
    if(gaa_arg_used[gaa_index] == 0)                                \
    {                                                               \
        GAA_FILL_2ARGS(target[num], func);                                \
        num++;                                                      \
    }                                                               \
}                                                                   \
if(num == 0)                                                        \
    return GAA_ERROR_NOTENOUGH_ARGS; \
}

#define GAA_OPTIONALLIST_FILL(target, func, type ,num)                      \
if(!OK) \
{ \
num = 0;                                                            \
target = malloc((gaa_last_non_option - gaa_index) * sizeof(type));  \
for(; gaa_index < gaa_last_non_option; gaa_index++)                 \
{                                                                   \
    if(gaa_arg_used[gaa_index] == 0)                                \
    {                                                               \
        GAA_FILL_2ARGS(target[num], func);                                \
        num++;                                                      \
    }                                                               \
} \
}

#define GAA_OBLIGAT(str)                                            \
k = 0;                                                              \
for(i = 0; i < strlen(str); i++)                                    \
{                                                                   \
    j = gaa_get_option_num(str + i, GAA_LETTER_OPTION);           \
    if(j == GAA_ERROR_NOMATCH)                                       \
    {                                                               \
        printf("Error : invalid 'obligat' set\n");                  \
        exit(-1);                                                   \
    }                                                               \
    if(opt_list[j] == 1)                                            \
        k = 1;                                                      \
}                                                                    \
if(k == 0)                                                            \
{                                                                      \
    if(strlen(str) == 1)                                                \
        printf("You must give the -%s option\n", str);                     \
    else                                                                  \
        printf("You must give at least one option of '%s'\n", str);          \
    return 0;         \
}
        
#define GAA_INCOMP(str)                                                \
k = 0;                                                              \
for(i = 0; i < strlen(str); i++)                                    \
{                                                                   \
    j = gaa_get_option_num(str + i, GAA_LETTER_OPTION);           \
    if(j == GAA_ERROR_NOMATCH)                                      \
    {                                                               \
        printf("Error : invalid 'obligat' set\n");                  \
        exit(-1);                                                   \
    }                                                               \
    if(opt_list[j] == 1)                                            \
        k++;                                                      \
}                   \
if(k > 1)                                                            \
{                                                                      \
    printf("The options '%s' are incompatible\n", str);              \
    return 0;                                                          \
}
        

char **GAAargv;
int GAAargc;
char *gaa_arg_used;
int gaa_processing_file = 0;
int inited = 0;

int gaa_getint(char *arg)
{
    int tmp;
    char a;
    if(sscanf(arg, "%d%c", &tmp, &a) != 1)
    {
        printf("Option %s : '%s' isn't an integer\n", gaa_current_option, arg);
        GAAERROR;
    }
    return tmp;
}

char gaa_getchar(char *arg)
{
    if(strlen(arg) != 1)
    {
        printf("Option %s : '%s' isn't an character\n", gaa_current_option, arg);
        GAAERROR;
    }
    return arg[0];
}

char* gaa_getstr(char *arg)
{
    return arg;
}
float gaa_getfloat(char *arg)
{
    float tmp;
    char a;
    if(sscanf(arg, "%f%c", &tmp, &a) != 1)
    {
        printf("Option %s : '%s' isn't a float number\n", gaa_current_option, arg);
        GAAERROR;
    }
    return tmp;
}
/* option structures */

struct GAAOPTION_strtoid 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_idtostr 
{
	int arg1;
	int size1;
};

struct GAAOPTION_strgenre 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_genre 
{
	int arg1;
	int size1;
};

struct GAAOPTION_tracknum 
{
	int arg1;
	int size1;
};

struct GAAOPTION_year 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_comment 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_album 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_artist 
{
	char* arg1;
	int size1;
};

struct GAAOPTION_songname 
{
	char* arg1;
	int size1;
};
#define GAA_REST_EXISTS

struct GAAREST
{
	char** arg1;
	int size1;
};
         
#line 349 "gaa.skel"
int gaa_is_an_argument(char *str)
{
#ifdef GAA_WIN32
    if(str[0] == '/' && str[1] != 0)
	return GAA_MULTIPLE_OPTION;
#endif
    if(str[0] != '-')
        return GAA_NOT_AN_OPTION;
    if(str[1] == 0)
        return GAA_NOT_AN_OPTION;
    if(str[1] == '-')
    {
        if(str[2] != 0)
            return GAA_WORD_OPTION;
        else
            return GAA_NOT_AN_OPTION;
    }
    if(str[2] == 0)
        return GAA_LETTER_OPTION;
    else
        return GAA_MULTIPLE_OPTION;
}

int gaa_get_option_num(char *str, int status)
{
    switch(status)
        {
        case GAA_LETTER_OPTION:
			GAA_CHECK1STR("j", GAAOPTID_strtoid);
			GAA_CHECK1STR("i", GAAOPTID_idtostr);
			GAA_CHECK1STR("G", GAAOPTID_strgenre);
			GAA_CHECK1STR("g", GAAOPTID_genre);
			GAA_CHECK1STR("t", GAAOPTID_tracknum);
			GAA_CHECK1STR("y", GAAOPTID_year);
			GAA_CHECK1STR("c", GAAOPTID_comment);
			GAA_CHECK1STR("l", GAAOPTID_album);
			GAA_CHECK1STR("a", GAAOPTID_artist);
			GAA_CHECK1STR("s", GAAOPTID_songname);
        case GAA_MULTIPLE_OPTION:
#line 375 "gaa.skel"
			GAA_CHECK1STR("v", GAAOPTID_verbose);
			GAA_CHECK1STR("L", GAAOPTID_listgenres);

#line 277 "gaa.skel"
        break;
        case GAA_WORD_OPTION:
			GAA_CHECKSTR("verbose", GAAOPTID_verbose);
			GAA_CHECKSTR("strtoid", GAAOPTID_strtoid);
			GAA_CHECKSTR("idtostr", GAAOPTID_idtostr);
			GAA_CHECKSTR("listgenres", GAAOPTID_listgenres);
			GAA_CHECKSTR("strgenre", GAAOPTID_strgenre);
			GAA_CHECKSTR("genre", GAAOPTID_genre);
			GAA_CHECKSTR("tracknum", GAAOPTID_tracknum);
			GAA_CHECKSTR("year", GAAOPTID_year);
			GAA_CHECKSTR("comment", GAAOPTID_comment);
			GAA_CHECKSTR("album", GAAOPTID_album);
			GAA_CHECKSTR("artist", GAAOPTID_artist);
			GAA_CHECKSTR("songname", GAAOPTID_songname);

#line 281 "gaa.skel"
	break;
        default: break;
        }
    return GAA_ERROR_NOMATCH;
}

int gaa_try(int gaa_num, int gaa_index, gaainfo *gaaval, char *opt_list)
{
    int OK = 0;
    int gaa_last_non_option;
	struct GAAOPTION_strtoid GAATMP_strtoid;
	struct GAAOPTION_idtostr GAATMP_idtostr;
	struct GAAOPTION_strgenre GAATMP_strgenre;
	struct GAAOPTION_genre GAATMP_genre;
	struct GAAOPTION_tracknum GAATMP_tracknum;
	struct GAAOPTION_year GAATMP_year;
	struct GAAOPTION_comment GAATMP_comment;
	struct GAAOPTION_album GAATMP_album;
	struct GAAOPTION_artist GAATMP_artist;
	struct GAAOPTION_songname GAATMP_songname;

#line 393 "gaa.skel"
#ifdef GAA_REST_EXISTS
    struct GAAREST GAAREST_tmp;
#endif

    opt_list[gaa_num] = 1;
    
    for(gaa_last_non_option = gaa_index;
        (gaa_last_non_option != GAAargc) && (gaa_is_an_argument(GAAargv[gaa_last_non_option]) == GAA_NOT_AN_OPTION);
        gaa_last_non_option++);

    if(gaa_num == GAA_REST)
    {
        gaa_index = 1;
        gaa_last_non_option = GAAargc;
    }
    
    switch(gaa_num)
    {
	case GAAOPTID_verbose:
	OK = 0;
#line 56 "Popol.gaa"
{ gaaval->verbose = 1; ;};

		return GAA_OK;
		break;
	case GAAOPTID_strtoid:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_strtoid.arg1, gaa_getstr, GAATMP_strtoid.size1);
		gaa_index++;
#line 48 "Popol.gaa"
{ 
		printf("genre `%s' has id %u\n", GAATMP_strtoid.arg1, genre_id_by_str(GAATMP_strtoid.arg1)); 
		exit(0); 
	;};

		return GAA_OK;
		break;
	case GAAOPTID_idtostr:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_idtostr.arg1, gaa_getint, GAATMP_idtostr.size1);
		gaa_index++;
#line 42 "Popol.gaa"
{ 
		printf("genre id %u is `%s'\n", GAATMP_idtostr.arg1, genre_str_by_id(GAATMP_idtostr.arg1)); 
		exit(0); 
	;};

		return GAA_OK;
		break;
	case GAAOPTID_listgenres:
	OK = 0;
#line 39 "Popol.gaa"
{ list_genres(); exit(0); ;};

		return GAA_OK;
		break;
	case GAAOPTID_strgenre:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_strgenre.arg1, gaa_getstr, GAATMP_strgenre.size1);
		gaa_index++;
#line 37 "Popol.gaa"
{ gaaval->strgenre = GAATMP_strgenre.arg1; gaaval->write_mode = 1 ;};

		return GAA_OK;
		break;
	case GAAOPTID_genre:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_genre.arg1, gaa_getint, GAATMP_genre.size1);
		gaa_index++;
#line 33 "Popol.gaa"
{ gaaval->genre = GAATMP_genre.arg1; gaaval->write_mode = 1;
			gaaval->want_genre = 1; ;};

		return GAA_OK;
		break;
	case GAAOPTID_tracknum:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_tracknum.arg1, gaa_getint, GAATMP_tracknum.size1);
		gaa_index++;
#line 22 "Popol.gaa"
{ 
			gaaval->tracknum = GAATMP_tracknum.arg1; 
			gaaval->write_mode = 1; 
			gaaval->want_track = 1;
			;};

		return GAA_OK;
		break;
	case GAAOPTID_year:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_year.arg1, gaa_getstr, GAATMP_year.size1);
		gaa_index++;
#line 18 "Popol.gaa"
{ gaaval->year = GAATMP_year.arg1; gaaval->write_mode = 1 ;};

		return GAA_OK;
		break;
	case GAAOPTID_comment:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_comment.arg1, gaa_getstr, GAATMP_comment.size1);
		gaa_index++;
#line 15 "Popol.gaa"
{ gaaval->comment = GAATMP_comment.arg1; gaaval->write_mode = 1 ;};

		return GAA_OK;
		break;
	case GAAOPTID_album:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_album.arg1, gaa_getstr, GAATMP_album.size1);
		gaa_index++;
#line 12 "Popol.gaa"
{ gaaval->album = GAATMP_album.arg1; gaaval->write_mode = 1  ;};

		return GAA_OK;
		break;
	case GAAOPTID_artist:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_artist.arg1, gaa_getstr, GAATMP_artist.size1);
		gaa_index++;
#line 9 "Popol.gaa"
{ gaaval->artist = GAATMP_artist.arg1; gaaval->write_mode = 1 ;};

		return GAA_OK;
		break;
	case GAAOPTID_songname:
	OK = 0;
		GAA_TESTMOREARGS;
		GAA_FILL(GAATMP_songname.arg1, gaa_getstr, GAATMP_songname.size1);
		gaa_index++;
#line 6 "Popol.gaa"
{ gaaval->songname = GAATMP_songname.arg1; gaaval->write_mode = 1 ;};

		return GAA_OK;
		break;
	case GAA_REST:
		GAA_LIST_FILL(GAAREST_tmp.arg1, gaa_getstr, char*, GAAREST_tmp.size1);
#line 62 "Popol.gaa"
{ gaaval->files = GAAREST_tmp.arg1; gaaval->files_num = GAAREST_tmp.size1 ;};

		return GAA_OK;
		break;

#line 413 "gaa.skel"
    default: break;
    }
    return GAA_ERROR_UNKNOWN;
}

int gaa(int argc, char **argv, gaainfo *gaaval)
{
    int tmp1, tmp2;
    int i, j, k;
    char *opt_list;

    GAAargv = argv;
    GAAargc = argc;

    opt_list = (char*) malloc(GAA_NB_OPTION + 1);
    for(i = 0; i < GAA_NB_OPTION + 1; i++)
        opt_list[i] = 0;
    /* initialization */
    if(inited == 0)
    {

#line 64 "Popol.gaa"
{ 	gaaval->songname = NULL; gaaval->artist=NULL; gaaval->album = NULL; 
	gaaval->comment = NULL; gaaval->year = NULL; 
	gaaval->genre = 0; gaaval->want_genre = 0; gaaval->strgenre = NULL;
	gaaval->tracknum = 0; gaaval->want_track = 0;
	gaaval->files = NULL; gaaval->files_num = 0; 
	gaaval->write_mode = 0; gaaval->verbose = 0; ;};

    }
    inited = 1;
#line 438 "gaa.skel"
    gaa_arg_used = malloc(argc * sizeof(char));
    for(i = 1; i < argc; i++)
        gaa_arg_used[i] = 0;
    for(i = 1; i < argc; i++)
    {
        if(gaa_arg_used[i] == 0)
        {
            j = 0;
            tmp1 = gaa_is_an_argument(GAAargv[i]);
            switch(tmp1)
            {
            case GAA_WORD_OPTION:
                j++;
            case GAA_LETTER_OPTION:
                j++;
                tmp2 = gaa_get_option_num(argv[i]+j, tmp1);
                if(tmp2 == GAA_ERROR_NOMATCH)
                {
                    printf("Invalid option '%s'\n", argv[i]+j);
                    return 0;
                }
                switch(gaa_try(tmp2, i+1, gaaval, opt_list))
                {
                case GAA_ERROR_NOTENOUGH_ARGS:
                    printf("'%s' : not enough arguments\n",gaa_current_option);
                    return 0;
                case GAA_ERROR_INVALID_ARG:
                    printf("Invalid arguments\n");
                    return 0;
                case GAA_OK:
                    break;
                default:
                    printf("Unknown error\n");
                }
                gaa_arg_used[i] = 1;
                break;
            case GAA_MULTIPLE_OPTION:
                for(j = 1; j < strlen(argv[i]); j++)
                {
                    tmp2 = gaa_get_option_num(argv[i]+j, tmp1);
                    if(tmp2 == GAA_ERROR_NOMATCH)
                    {
                        printf("Invalid option '%c'\n", *(argv[i]+j));
                        return 0;
                    }
                    switch(gaa_try(tmp2, i+1, gaaval, opt_list))
                    {
                    case GAA_ERROR_NOTENOUGH_ARGS:
                        printf("'%s' : not enough arguments\n",gaa_current_option);
                        return 0;
                    case GAA_ERROR_INVALID_ARG:
                        printf("Invalid arguments\n");
                        return 0;
                    case GAA_OK:
                        break;
                    default:
                        printf("Unknown error\n");
                    }
                }
                gaa_arg_used[i] = 1;
                break;
            default: break;
            }
        }
    }
if(gaa_processing_file == 0)
{
	GAA_INCOMP("gG");

#line 507 "gaa.skel"
#ifdef GAA_REST_EXISTS
    switch(gaa_try(GAA_REST, 1, gaaval, opt_list))
    {
    case GAA_ERROR_NOTENOUGH_ARGS:
        printf("Rest : not enough arguments\n");
        return 0;
    case GAA_ERROR_INVALID_ARG:
        printf("Invalid arguments\n");
        return 0;
    case GAA_OK:
        break;
    default:
        printf("Unknown error\n");
    }
#endif
}
    for(i = 1; i < argc; i++)
    {
        if(gaa_arg_used[i] == 0)
        {
            printf("Too many arguments\n");
            return 0;
        }
    }
    free(gaa_arg_used);
    free(opt_list);
    return -1;
}

struct gaastrnode
{
    char *str;
    struct gaastrnode *next;
};

typedef struct gaastrnode gaa_str_node;

int gaa_internal_get_next_str(FILE *file, gaa_str_node *tmp_str, int argc)
{
    int pos_ini;
    char a;
    int i = 0, len = 0, newline = 0;

    if(argc == 1)
        newline = 1;
    
    if(fscanf(file,"%c", &a) != 1) return 0;

    while(a == ' ' || a == 9 || a == '\n')
    {
        if(a == '\n')
        {
            newline=1;
            len = 2;
        }
        if(fscanf(file,"%c", &a) != 1) return 0;
    }

    pos_ini = ftell(file) - 1;

    while(a != ' ' && a != 9 && a != '\n')
    {

        len++;
        if(fscanf(file,"%c", &a) != 1) a = ' ';
    }
    
    tmp_str->str = malloc((len + 1) * sizeof(char));
    if(newline == 1)
    {
        tmp_str->str[0] = '-';
        tmp_str->str[1] = '-';
        i = 2;
    }
    else
    {
        i = 0;
    }

    fseek(file,pos_ini, SEEK_SET);
    do
    {
        if(fscanf(file, "%c", &a) != 1)
        {
            i+=2;
            break;
        }
        tmp_str->str[i] = a;
        i++;
    }
    while(a != ' ' && a != 9 && a != '\n');

    tmp_str->str[i - 1] = 0;

    fseek(file,- 1, SEEK_CUR);
//    printf("%d\n", ftell(file));
    
    return -1;
}

int gaa_file(char *name, gaainfo *gaaval)
{
    gaa_str_node *first_str, **tmp_str, *tmp_str2;
    int rval, i;
    char **argv;
    int argc = 0;
    FILE *file;

    gaa_processing_file = 1;
    
    if((file = fopen(name, "r")) == NULL)
    {
        printf("Couldn't open '%s' configuration file for reading\n", name);
        return 0;
    }
    
    tmp_str = &first_str;
    do
    {
        argc++;
        *tmp_str = malloc(sizeof(gaa_str_node));
        (*tmp_str)->str = NULL;
        (*tmp_str)->next = NULL;

        rval = gaa_internal_get_next_str(file, *tmp_str, argc);
        tmp_str = &((*tmp_str)->next);
    }
    while(rval == -1);
    
    if(rval == 1)
        return 0;
    
    argv = malloc((1 + argc) * sizeof(char*));
    tmp_str2 = first_str;
    argv[0] = "cfg";
    for(i = 1; i < argc; i++)
    {
        argv[i] = tmp_str2->str;
        tmp_str2 = tmp_str2->next;
    }

    rval = gaa(argc, argv, gaaval);
    gaa_processing_file = 0;
    return rval;
}
