/*
    Popol, ID3v1.1 *safe* tagger :)   
    Copyright (C) 1999  XSFX <XSFX@linuxfreak.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 */ 

#include <stdio.h> 
#include <string.h>
#include <stdlib.h>

#define TAG_APPEND  29
#define TAG_REPLACE 42

#define READ_SEEK_FAILED ((void *) -1)

extern int verbose;
extern int force_mtag_repair;

typedef struct id3tag
{
        char songname[31];
        char artist[31];
        char album[31];
        char year[5];
        char comment[31];
        unsigned char tracknum;
        unsigned char genre;

        char filename[FILENAME_MAX];
	int write_method;
} tag_t;

/* Prototypes for id3.c */
void echo_tag(tag_t *id3tag);
void list_genres();
char *genre_str_by_id (unsigned char genre);
unsigned char genre_id_by_str (char *str);
tag_t *read_id3(FILE *mp3file, char *filename);
void write_id3(FILE *mp3file, tag_t *id3tag);
int count_id3(FILE *mp3file);

/* Prototypes for main.c */
void print_usage(char *program_name);
int main (int argc, char **argv);

/* Prototypes for lib.c */
FILE *openvalidmp3(char *filename, char *mode);
char *basename(char *str);
long fsizeof (FILE *file);
