#include <sys/stat.h>
#include <unistd.h>
#include "common.h"

FILE *openvalidmp3(char *filename, char *mode)
{
	FILE *file;
	struct stat mp3stat;
 	
	if (stat(filename,&mp3stat) != 0) { perror(filename); return NULL; }
	if (!S_ISREG(mp3stat.st_mode)) { 
		printf("%s: not a regular file\n",
			filename);
		return NULL;
	}
	if(strcasecmp(&filename[strlen(filename)-3],"mp3") != 0) {
		fprintf(stderr,"%s: not a .mp3\n",
			filename);
		return NULL;	
	}		
	if ((file = fopen(filename, mode)) == NULL) {
		perror(filename);
		return NULL;
	}
	else return file;
}

char *basename(char *str)
{
	char *rval;
	
	rval = strrchr(str, '/');
	if (rval != NULL && (rval < (str + strlen(str) - 1))) return (rval+1);
	else return str;
}

long fsizeof (FILE *file)
{
	long init_pos;
	long ret_pos;

	init_pos = ftell(file);
	fseek(file, 0, SEEK_END);
	ret_pos = ftell(file);
	fseek(file, ret_pos, SEEK_SET);
	
	return ret_pos;
}	

/*
		mp3file = openvalidmp3(filv[i],"r");
	        if (mp3file)
		{
			f = count_id3(mp3file);
			fclose(mp3file);
			
			if (f > 0) 
			{
			 if (truncate(filv[i],(fsizeof(mp3file) - f*128)) != 0)
				{
					fprintf(stderr, "%s: ", filv[i]);
					perror("truncate");
				}
*/				
